#############################################################################
# Platform specific information
# 
# Edit these variables for for different paltforms
#
#############################################################################

#-------- COMPILE_OPTION= 
#-------- MWCONFIG_NAME = 
#-------- GNULIBDIR     = 
#-------- STDCLIBDIR    = 
#-------- PLATFORM_SPECIFIC_LIBS = 
#-------- MWOS                   =  
#-------- EXTENSION	= 


#-------------- solaris 2.7 --------------------
COMPILE_OPTION= retail
MWCONFIG_NAME = solaris
GNULIBDIR     = /usr/local/lib/gcc-lib/sparc-sun-solaris2.7/2.8.1
STDCLIBDIR    = /usr/local/lib
P_LIBS        = -lsocket -lnsl -lpam
P_CFLAGS 	  = -Dsolaris
P_LDFLAGS 	  =
EXTENSION	  = so7
CC	          = gcc

#-- localtion of lib3des.a
TRIPLEDESDIR   = ../libs/${COMPILE_OPTION}/${MWCONFIG_NAME}

#############################################################################
# Verbosity Control in builds
# Information below taken from /vobs/mw/mw/make.noise
#############################################################################
MAKE_VERBOSE = TRUE

ifndef MAKE_VERBOSE
	NO_SHORT_ECHO = TRUE
endif
 
ifdef NO_SHORT_ECHO
 
ECHOOBJ    = @
ECHOTARGET = @
ECHOSOURCE = @
ECHOLIB    = @
ECHONOISE  = @true
 
else
 
ifndef DIRNOISE
	DIRNOISE := $(shell pwd)
endif
 
ECHOOBJ    = @echo "[ ${DIRNOISE} : $(notdir $<) --> $(notdir $@) ]"
ECHOTARGET = @echo "[ ${DIRNOISE} : $(notdir $@) ]"
ECHOSOURCE = @echo "[ ${DIRNOISE} : $(notdir $<) ]"
ECHOLIB    = @echo "[ -- ${DIRNOISE} : $(notdir $@) ]"
ECHONOISE  = @echo
 
endif
 
ifeq "$(strip ${MAKE_VERBOSE})"  "false"
.SILENT:
else
DASH_VERBOSE=-v
endif

#############################################################################
# Directories for Installation
#############################################################################

ifeq (${COMPILE_OPTION}, debug)
    OBJ = objd
    DFLAGS  = -g  ${MWOS}
    LDFLAGS = $(DFLAGS) -L${O} -Xlinker -dy
    OPTIMIZATION = 
	BUILDMSG     = "*** Building debug ssod module"
else
    OBJ = obj
    DFLAGS  = ${MWOS}
    LDFLAGS = $(DFLAGS) -L${O}  -Xlinker -dy
    OPTIMIZATION = -O3
	BUILDMSG     = "*** Building retail ssod module"
endif

O           =   ${OBJ}/i386
BINDIR      =   ./bin
SSODEXE    =   ${BINDIR}/ssod.${EXTENSION}
SSOD2PAMDLL    =   ${BINDIR}/ssod2pam.${EXTENSION}

#############################################################################
# Flags for Installation
#############################################################################

CFILES		= 		\
              messages.cpp  	\
              ssod2pam.cpp  	\
              sso_pakt.cpp  	\
              ssod.cpp        	\
              password.cpp    	\
              dimonfnc.cpp 	\
              crypto.cpp      	\
              sha1.cpp          \
              rotlr.cpp

HFILES		= 		\
              messages.h	\
              ssod2pam.h  	\
              sso_pakt.h  	\
              password.h    	\
              dimonfnc.h 	\
              crypto.h

OFILES		= 		\
              ${O}/messages.o   \
              ${O}/ssod2pam.o   \
              ${O}/ssod.o     	\
              ${O}/sso_pakt.o  	\
              ${O}/password.o  	\
              ${O}/dimonfnc.o   \
              ${O}/crypto.o     \
              ${O}/sha1.o   	\
              ${O}/rotlr.o


#############################################################################

IFLAGS    =  -I /usr/include


EXTRALIBS = ${P_LIBS} -Xlinker -B -Xlinker static -L${STDCLIBDIR} -lstdc++ -L${GNULIBDIR} -lgcc -L../libs/retail/solaris -l3des


CFLAGS    = $(OPTFLAGS) $(DFLAGS) $(P_CFLAGS) $(IFLAGS)   $(PLATFORM_CFLAGS)

OPTFLAGS    =  


#IFLAGS      = -I${GNUDIR}/include  -I/usr/include

#DEFINES 	= -DRENTRANT ${DMWOS} -D_TIMESPEC_T_ 

#CFLAGS		= $(OPTFLAGS) $(DFLAGS) ${PLATFORM_CFLAGS} $(IFLAGS) 

#############################################################################
# .sfx.o rules 
#############################################################################
.SUFFIXES: .cpp.c

#.cpp.o:
#    $(CC) $(CFLAGS) -c -o ${O}/$@ $<x
	
#.c.o:
#    $(CC) $(CFLAGS) -c -o ${O}/$@ $<x
    
#############################################################################

all: alldirs info  ${SSODEXE}

alldirs: ${O} ${BINDIR}

info:
	@echo
	@echo ${BUILDMSG}
	@echo

${SSODEXE}: $(OFILES) 
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(DFLAGS) -o $@ $(OFILES) ${EXTRALIBS} $(PLATFORM_SPECIFIC_LIBS) -Xlinker -dy  -Xlinker -B -Xlinker dynamic -lgcc -lnsl 


${O}/ssod.o : ssod.cpp password.h sso_pakt.h dimonfnc.h
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(CFLAGS) -c -o $@ $< 

${O}/password.o : password.cpp password.h
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(CFLAGS) -c -o $@ $<

${O}/sso_pakt.o : sso_pakt.cpp sso_pakt.h
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(CFLAGS) -c -o $@ $<

${O}/dimonfnc.o : dimonfnc.cpp dimonfnc.h
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(CFLAGS) -c -o $@ $<

${O}/crypto.o : crypto.cpp ../common/crypto.h
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(CFLAGS) -c -o $@ $<

${O}/sha1.o : ../common/sha1.cpp ../common/sha1.h
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(CFLAGS) -c -o $@ $<

${O}/rotlr.o : ../common/rotlr.cpp
	$(CC) $(CFLAGS) -c -o $@ $<

${O}/messages.o : ../common/messages.cpp
	$(CC) $(CFLAGS) -c -o $@ $<

${O} ${BINDIR}:
	${ECHONOISE} "[ $@ ]"


install:
	chown root $(SSODEXE)
	cp -f $(SSODEXE)        /usr/bin/ssod


clean:
	rm -f $(OFILES) $(SSODEXE) *~ core ${O}/*

realclean: clean
	rm -rf $(OFILES) $(SSODEXE) *~ core ${O}/*

#############################################################################

cpamlink : clean ssod2pam ${SSODEXE}

# build ssod2pam.so.1

ssod2pam: ${O}/ssod2pam.o
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) -G  -o ${O}/$@.so.1 $< -lgcc -lpam 
	
${O}/ssod2pam.o: ssod2pam.cpp
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(CFLAGS)  -c -o $@ $<

#############################################################################
#	for test stub
#############################################################################

# build ssodlink

ssodlink: ssod2pam ${O}/ssodlink.o
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(DFLAGS)    -o ./ssod  ${O}/ssodlink.o  ${O}/ssod2pam.o -lpam  -lgcc 
	


${O}/ssodlink.o: ssodlink.cpp
	${ECHONOISE} "[ $< -> $@ ]"
	$(CC) $(CFLAGS) -c -o $@ $<




